module Database.Redis.String.Tests
    ( tests ) where


------------------------------------------------------------------------------
import           Test.Framework (Test)
import           Test.Framework.Providers.HUnit
-- import           Test.Framework.Providers.QuickCheck2
import qualified Test.HUnit as H
-- import           Test.QuickCheck
-- import           Test.QuickCheck.Monadic

import           Database.Redis


------------------------------------------------------------------------------
-- N.B. These aren't proper tests yet, just checks


------------------------------------------------------------------------------
tests :: [Test]
tests = [ testCase "redis itemSet"       itemSetTest
        , testCase "redis itemGet"       itemGetTest
        , testCase "redis itemGetB"      itemGetBTest
        ]


------------------------------------------------------------------------------
itemSetTest :: H.Assertion
itemSetTest = do
    con <- connect localhost defaultPort
    _ <- select con 0
    returning <- itemSet con "akey" "ἐστίν"
    _ <- keyDelete con ["akey"]
    disconnect con
    H.assertEqual "itemSet" (Just $ RedisSingle $ toUTF8 "OK") returning


------------------------------------------------------------------------------
itemGetTest :: H.Assertion
itemGetTest = do
    con <- connect localhost defaultPort
    _ <- select con 0
    _ <- itemSet con "differentKey" "ἐστίν"
    returning <- itemGet con "differentKey"
    _ <- keyDelete con ["differentKey"]
    disconnect con
    H.assertEqual "itemGet" (Just $ RedisBulk [Just (RedisSingle $ toUTF8 "ἐστίν")]) returning


------------------------------------------------------------------------------
itemGetBTest :: H.Assertion
itemGetBTest = do
    con <- connect localhost defaultPort
    _ <- select con 0
    _ <- itemSetB con (toUTF8 "bKey") (toUTF8 "ἐστίν")
    returning <- itemGetB con (toUTF8 "bKey")
    _ <- keyDelete con ["bKey"]
    disconnect con
    H.assertEqual "itemGet" (Just $ RedisBulk [Just (RedisSingle $ toUTF8 "ἐστίν")]) returning


